//+------------------------------------------------------------------+
//|                                                 Setka.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double  Lots             = 0.1;
extern double  Lots_1           = 0.2;
extern double  Lots_2           = 0.4;
extern double  Lots_3           = 0.8;

extern string Coment            = "Pattern_1";
extern int TakeProfit           = 200;     
extern int StopLoss             = 200;   
extern int StepOtl_1            = 200;   
extern int StepOtl_2            = 400;   
extern int StepOtl_3            = 600;   

extern int BULevel              = 2;
extern int NotBULevel           = 2;  //    

extern int Slippage             = 2;  //  
extern int Magic                = 111;

int ttb, ttb_1, ttb_2, ttb_3, tts, tts_1, tts_2, tts_3;            //  
int bs, ss, bsts, ssts, slms, blms;    // .    
bool Alowed, Sell, Buy; //    
//+------------------------------------------------------------------+
int init()
{
 int slv=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(StepOtl_1<=slv || StepOtl_2<=slv || StepOtl_3<=slv || BULevel <=slv || NotBULevel<=slv) 
 {
  Print("  "); 
  Alowed=false;
  return(0);
 }
  Alowed=true;
 return(0);
}
//+------------------------------------------------------------------+
//-------------------------------------------------------------------+
int start()
{
int i;
double TP,SL;
if(!Alowed) return(0);
CountTrades();

if(bs+ss+bsts+ssts+blms+slms==0)
{//  ,      
 if(bs+ss==0 && Volume[0]<=1)   

 {
  if (Open[1]>Close[1] && Open[2]<Close[2] && High[1]>High[2] && Low[1]<Low[2])  // 
  {
   TP=NormalizeDouble(Ask-TakeProfit*Point,Digits);  
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask+StopLoss*Point+StopLoss*Point,Digits);
   if(StopLoss==0) SL=0;
   tts = OrderSend(Symbol(),1,Lots,Bid,Slippage,SL,TP,"Pattern_1",Magic,0,Red);
   if(tts>0)
   {
    Sell=true;
    TP=NormalizeDouble(Ask+StepOtl_1*Point-TakeProfit*2*Point,Digits); 
    if(TakeProfit==0) TP=0;
    SL=NormalizeDouble(Ask+StepOtl_1*Point+StopLoss*2*Point,Digits);
    if(StopLoss==0) SL=0;
    tts_1 = OrderSend(Symbol(),OP_SELLLIMIT,Lots_1,NormalizeDouble(Bid+StepOtl_1*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Red);// 
   
    TP=NormalizeDouble(Ask+StepOtl_1*Point+TakeProfit*Point,Digits);
    if(TakeProfit==0) TP=0;
    SL=NormalizeDouble(Ask+StepOtl_1*Point-StopLoss*2*Point,Digits);
    if(StopLoss==0) SL=0;
    ttb_1 = OrderSend(Symbol(),OP_BUYSTOP,Lots_1,NormalizeDouble(Ask+StepOtl_1*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Blue);// 
    
    TP=NormalizeDouble(Ask+StepOtl_2*Point-TakeProfit*Point,Digits);
    if(TakeProfit==0) TP=0;
    SL=NormalizeDouble(Ask+StepOtl_2*Point+StopLoss*2*Point,Digits);
    if(StopLoss==0) SL=0;
    tts_2 = OrderSend(Symbol(),OP_SELLLIMIT,Lots_2,NormalizeDouble(Bid+StepOtl_2*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Red); // 
    
    TP=NormalizeDouble(Ask+StepOtl_2*Point+TakeProfit*Point,Digits);
    if(TakeProfit==0) TP=0;
    SL=NormalizeDouble(Ask+StepOtl_2*Point-StopLoss*2*Point,Digits);
    if(StopLoss==0) SL=0;
    ttb_2 = OrderSend(Symbol(),OP_BUYSTOP,Lots_2,NormalizeDouble(Ask+StepOtl_2*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Blue); // 
    
    TP=NormalizeDouble(Ask+StepOtl_3*Point-TakeProfit*Point,Digits);
    if(TakeProfit==0) TP=0;
    SL=NormalizeDouble(Ask+StepOtl_3*Point+StopLoss*Point,Digits);
    if(StopLoss==0) SL=0;
    tts_3 = OrderSend(Symbol(),OP_SELLLIMIT,Lots_3,NormalizeDouble(Bid+StepOtl_3*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Red); // 
    
    TP=NormalizeDouble(Ask+StepOtl_3*Point+TakeProfit*Point,Digits);
    if(TakeProfit==0) TP=0;
    SL=NormalizeDouble(Ask+StepOtl_3*Point-StopLoss*Point,Digits);
    if(StopLoss==0) SL=0;
    ttb_3 = OrderSend(Symbol(),OP_BUYSTOP,Lots_3,NormalizeDouble(Ask+StepOtl_3*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Blue); // 
    
    }
   }
  }
 }

  /*
 if (Open[1]<Close[1] && Open[2]>Close[2] && High[1]>High[2] && Low[1]<Low[2]) // 
 {
  TP=NormalizeDouble(Bid+TakeProfit*Point,Digits); 
  if(TakeProfit==0) TP=0;
  SL=NormalizeDouble(Ask-StopLoss*Point-StopLoss*Point,Digits);
  if(StopLoss==0) SL=0;
  ttb = OrderSend(Symbol(),0,Lots,Ask,Slippage,SL,TP,"Pattern_1",Magic,0,Blue);
  if(ttb>0)
  { 
   Buy=true;
   TP=NormalizeDouble(Ask-StepOtl_1*Point+TakeProfit*2*Point,Digits); // Bid
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask-StepOtl_1*Point-StopLoss*2*Point,Digits);
   if(StopLoss==0) SL=0;
   ttb_1 = OrderSend(Symbol(),OP_BUYLIMIT,Lots_1,NormalizeDouble(Ask-StepOtl_1*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Blue);// 
   
   TP=NormalizeDouble(Ask-StepOtl_1*Point-TakeProfit*Point,Digits);
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask-StepOtl_1*Point+StopLoss*2*Point,Digits); // Bid
   if(StopLoss==0) SL=0;
   tts_1 = OrderSend(Symbol(),OP_SELLSTOP,Lots_1,NormalizeDouble(Bid-StepOtl_1*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Red);// 
   
   TP=NormalizeDouble(Ask-StepOtl_2*Point+TakeProfit*Point,Digits);
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask-StepOtl_2*Point-StopLoss*2*Point,Digits);
   if(StopLoss==0) SL=0;
   ttb_2 = OrderSend(Symbol(),OP_BUYLIMIT,Lots_2,NormalizeDouble(Ask-StepOtl_2*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Blue);// 
   
   TP=NormalizeDouble(Ask-StepOtl_2*Point-TakeProfit*Point,Digits);
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask-StepOtl_2*Point+StopLoss*2*Point,Digits);
   if(StopLoss==0) SL=0;
   tts_2 = OrderSend(Symbol(),OP_SELLSTOP,Lots_2,NormalizeDouble(Bid-StepOtl_2*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Red);// 
   
   
   TP=NormalizeDouble(Ask-StepOtl_3*Point+TakeProfit*Point,Digits);
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask-StepOtl_3*Point-StopLoss*Point,Digits);
   if(StopLoss==0) SL=0;
   ttb_3 = OrderSend(Symbol(),OP_BUYLIMIT,Lots_3,NormalizeDouble(Ask-StepOtl_3*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Blue);
   
   TP=NormalizeDouble(Ask-StepOtl_3*Point-TakeProfit*Point,Digits);
   if(TakeProfit==0) TP=0;
   SL=NormalizeDouble(Ask-StepOtl_3*Point+StopLoss*Point,Digits);
   if(StopLoss==0) SL=0;
   tts_3 =OrderSend(Symbol(),OP_SELLSTOP,Lots_3,NormalizeDouble(Bid-StepOtl_3*Point,Digits),Slippage,SL,TP,"Pattern_1",Magic,0,Red);
  }
 }
}
*/

//   
if(bs+ss+blms+slms+bsts+ssts==6 || bs+ss+blms+slms+bsts+ssts==4 || bs+ss+blms+slms+bsts+ssts==2)
{
 for(i=OrdersTotal()-1; i>=0; i--)
 {
  if(OrderSelect(i,SELECT_BY_POS))
  {
   if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic) continue;
   int typ=OrderType();
   int tic=OrderTicket();
   double oop=OrderOpenPrice();
   double olt=OrderLots();
   
   if(typ>=2) OrderDelete(tic);
  }
 }
 
     if (blms+slms+bsts+ssts==0) 
    {
    if(OrderSelect(tts_2, SELECT_BY_TICKET ,MODE_TRADES))
    OrderModify(tts_2,OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),0,0);
    }
   /* 
    if (blms+slms+bsts+ssts==0) 
    {
    if(OrderSelect(ttb_2, SELECT_BY_TICKET ,MODE_TRADES))
    OrderModify(ttb_2,OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),0,0);
    }
*/
 Buy=false; Sell=false;
}
   return(0);
  }
//+------------------------------------------------------------------+

//    --------------------------------+
void CountTrades()
{
 bs=0; ss=0; blms=0;  slms=0; bsts=0; ssts=0;
 for(int i=OrdersTotal()-1; i>=0; i--) 
 {
  if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES))
  { 
   if(OrderSymbol()!=Symbol() && OrderMagicNumber()!=Magic) continue;
   int typ=OrderType();
   int tic=OrderTicket();
   double oop=OrderOpenPrice();      
   switch (typ)
   {
    case 0: bs++;   break;
    case 1: ss++;   break;
    case 2: blms++; break;
    case 3: slms++; break;
    case 4: bsts++; break;
    case 5: ssts++; break;
    default: break; 
   }        
  }
 }
 return;  
}

//+------------------------------------------------------------------+


